--- pyscanner.l.old	2006-10-20 23:12:45.000000000 -0400
+++ pyscanner.l	2006-10-20 23:12:51.000000000 -0400
@@ -139,7 +139,8 @@
 static void newEntry()
 {
   previous = current;
-  current_root->addSubEntry(current);
+  if (current_root != current)
+	current_root->addSubEntry(current);
   current = new Entry ;
   initEntry();
 }
@@ -495,6 +496,7 @@
     "def"{BB}           { // start of a function/method definition
       			  g_indent=computeIndent(yytext);
                           //g_expectModuleDocs = FALSE;
+				newEntry();
 			  current->fileName  = yyFileName;
 			  current->startLine = yyLineNr;
 			  current->bodyLine  = yyLineNr;
@@ -515,6 +517,7 @@
      "class"{BB}        {  // start of a class definition
       			  g_indent=computeIndent(yytext);
                           //g_expectModuleDocs = FALSE;
+			newEntry();
 			  current->section = Entry::CLASS_SEC;
 			  current->argList->clear();
 			  current->type += "class" ;
@@ -525,15 +528,18 @@
                        }
      ^{B}"from"{BB}    |
      "from"{BB}	       { // start of an from import
+					newEntry();
                           BEGIN( FromMod );
                        }
 
      ^{B}"import"{BB}  |
      "import"{BB}      { // start of an import statement
+						newEntry();
                           BEGIN( Import );
                        }
      ^{B}{IDENTIFIER}/{B}"="[^=] { // variable
       			g_indent=computeIndent(yytext);
+				newEntry();
       			current->section   = Entry::VARIABLE_SEC;
 			current->name      = QCString(yytext).stripWhiteSpace();
 			current->fileName  = yyFileName;
@@ -566,6 +572,7 @@
                       }
 
     {NEWLINE}+        { // new line
+						g_specialBlock = FALSE;
                         lineCount();
                       }
 
@@ -1479,12 +1486,11 @@
 
     current_root  = current ;
     initParser();
-    current       = new Entry;
 
     groupEnterFile(yyFileName,yyLineNr);
     
-    current->reset();
     pyscanYYrestart( pyscanYYin );
+	g_specialBlock = TRUE;
     BEGIN( Search );
     pyscanYYlex();
     g_lexInit=TRUE;
